/**
 * On Document Ready
 */
jQuery(document).ready(
    function () {

        jQuery("#woo_wheel_settings_scroll_trigger_by_class").prop("readonly", true);

        jQuery('.ww-image-box').on(
            'click', function (e) {
                e.preventDefault();
                var frame = wp.media.frames.file_frame = wp.media(
                    {
                        title: 'Select or Upload Image',
                        button: {
                            text: 'Use as Image'
                        },
                        multiple: false
                    }
                );
                frame.on(
                    'select', function () {
                        var attachment = frame.state().get('selection').first().toJSON();
                     
                        if(jQuery("#spin_wheel_image").length ) {
                            jQuery("#spin_wheel_image").remove();
                        }
                        jQuery('.clickable-button-icon').append('<input type="hidden" value="'+ attachment.id + '" name="spin_wheel_image" id="spin_wheel_image" />');
                        jQuery('.ww-image-box').html('<img src="' + attachment.url + '" alt="Selected Image" style="max-width: 100%; height: auto;">');

                    }
                );

                frame.open();
            }
        );

        couponTypeChanged();

        jQuery("#woo_wheel_clickable_tab_image").change(
            function () {
                readImageURL(this, '.ww-image-box', 80);
            }
        );

        jQuery(".ww-image-box").change(
            function () {
                readImageURL(this, '#woo_wheel_clickable_tab_image', 80);
            }
        );

    
        jQuery("#woo_wheel_wheel_center_logo").change(
            function () {
                readImageURL(this, '.ww-wheel-logo', 150);
            }
        );

        jQuery("#woo_wheel_logo").change(
            function () {
                readImageURL(this, '.woo-wheel-logo', 150);
            }
        );

        // Remove Image
        jQuery('span.remove-image').click(
            function () {
                var remove_image = jQuery(this);
                var image_id = remove_image.data('img');

                var data = {
                    'action': 'remove_image',
                    'image_id': image_id,
                    'security': woo_wheel_slices.ajax_nonce,
                };

                // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
                jQuery.post(
                    woo_wheel_slices.ajax_url, data, function (response) {
                        remove_image.next().find('img').remove();
                    }
                );
            }
        );

        jQuery(".woo-wheel-slices input[type=checkbox]").on(
            "change", function () {
                jQuery(this).closest("tr").toggleClass("selected", this.checked);
       
            }
        );

        jQuery("#deleteButton").on(
            "click", function () {
                jQuery('.selected').remove();
            }
        );
    
        // Change Select2 Placeholder
        setTimeout(
            function () {
                jQuery('select[name="woo_wheel_settings_select_pages[]"]').next('.select2').find('input.select2-search__field').attr('placeholder', 'Choose Pages...');
            },10
        );

        jQuery('a.select_none').click(
            function () {
                setTimeout(
                    function () {
                        jQuery('select[name="woo_wheel_settings_select_pages[]"]').next('.select2').find('input.select2-search__field').attr('placeholder', 'Choose Pages...');
                    }, 10
                );
            }
        );

        setTimeout(
            function () {
                jQuery('select[name="woo_wheel_settings_select_posts[]"]').next('.select2').find('input.select2-search__field').attr('placeholder', 'Choose Posts...');
            }, 10
        );

        jQuery('a.select_none').click(
            function () {
                setTimeout(
                    function () {
                        jQuery('select[name="woo_wheel_settings_select_posts[]"]').next('.select2').find('input.select2-search__field').attr('placeholder', 'Choose Posts...');
                    }, 10
                );
            }
        );
    }
);

function readImageURL(input, elem, max_size)
{
    if (input.files && input.files[0]) {
        var reader = new FileReader();

        jQuery('.error-size').remove();

        reader.onload = function (e) {

            var image = new Image();
            jQuery(elem).html('<img src="' + e.target.result + '" />');

            image.src = reader.result;

            image.onload = function () {

                if (image.width > max_size) {
                    jQuery(elem).after('<div class="error-size" style="color:red">Image size should be ' + max_size + 'x' + max_size + '</div>');
                }
            };
        }

        reader.readAsDataURL(input.files[0]);
    }
}

/**
 * Function ColorPicker for use in wheel slices
 */
function colorPicker()
{
    jQuery('.colorpick')

        .iris(
            {
                change: function (event, ui) {
                    jQuery(this).parent().find('.colorpickpreview').css({ backgroundColor: ui.color.toString() });
                    // jQuery( this ).closest( 'td' ).css('cssText','background-color:red');
                },
                hide: true,
                border: true
            }
        )

        .on(
            'click focus', function (event) {
                event.stopPropagation();
                jQuery('.iris-picker').hide();
                jQuery(this).closest('td').find('.iris-picker').show();
                jQuery(this).data('original-value', jQuery(this).val());
            }
        )

        .on(
            'change', function () {
                if (jQuery(this).is('.iris-error')) {
                    var original_value = jQuery(this).data('original-value');

                    if (original_value.match(/^\#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})$/)) {
                        jQuery(this).val(jQuery(this).data('original-value')).change();
                        jQuery(this).closest('td').css('cssText', 'background-color:red');
                    } else {
                        jQuery(this).val('').change();
                    }
                }
            }
        );

    jQuery('body').on(
        'click', function () {
            jQuery('.iris-picker').hide();
        }
    );
}

/**
 * Coupon Type on Change Functionality
 */
function couponTypeChanged()
{
    jQuery('.ww_coupon_type').change(
        function () {

            var row = jQuery(this).closest('tr');
            if (jQuery(this).val() == 'coupon') {
                row.find('td select.woo_coupon.fix').removeClass('ww-hide');
                row.find('td select.woo_coupon.auto').addClass('ww-hide');
                row.find('td input.coupon_text').addClass('ww-hide');
            } else if (jQuery(this).val() == 'coupon_auto') {
                row.find('td select.woo_coupon.fix').addClass('ww-hide');
                row.find('td select.woo_coupon.auto').removeClass('ww-hide');
                row.find('td input.coupon_text').addClass('ww-hide');
                 row.find('td input.coupon_value').removeAttr('placeholder','');
                 row.find('td input.coupon_value').removeAttr('readOnly','readOnly');
            } else {
                row.find('td input.coupon_text').removeClass('ww-hide');
                row.find('td select.woo_coupon').addClass('ww-hide');
            }

            setCouponText(jQuery(this).val(), row);
        }
    );
}

/**
 * Coupon Text Depending on Coupon Type
 */
function setCouponText($couponType, $row)
{

    if ($couponType == 'coupon') {
        $row.find('input.coupon_text').hide();
        $row.find('select.woo_coupon').show();
    } else {
        $row.find('input.coupon_text').show();
        $row.find('select.woo_coupon').hide();
    }
}

jQuery(document).ready(
    function () {
        couponTypeChanged(), jQuery(".ww-image-box").click(
            function () {
                //jQuery("#woo_wheel_clickable_tab_image").click()
            }
        ), jQuery("#woo_wheel_clickable_tab_image").change(
            function () {
                readImageURL(this, ".ww-image-box", 80)
            }
        ), jQuery("span.remove-image").click(
            function () {
                var e = jQuery(this),
                o = {
                    action: "remove_image",
                    image_id: e.data("img"),
                    security: woo_wheel_slices.ajax_nonce
                };
                jQuery.post(
                    woo_wheel_slices.ajax_url, o, function (o) {
                        e.next().find("img").remove()
                    }
                )
            }
        ), setTimeout(
            function () {
                jQuery('select[name="woo_wheel_settings_select_pages[]"]').next(".select2").find("input.select2-search__field").attr("placeholder", "Choose Pages...")
            }, 10
        ), jQuery("a.select_none").click(
            function () {
                setTimeout(
                    function () {
                        jQuery('select[name="woo_wheel_settings_select_pages[]"]').next(".select2").find("input.select2-search__field").attr("placeholder", "Choose Pages...")
                    }, 10
                )
            }
        ), setTimeout(
            function () {
                jQuery('select[name="woo_wheel_settings_select_posts[]"]').next(".select2").find("input.select2-search__field").attr("placeholder", "Choose Posts...")
            }, 10
        ), jQuery("a.select_none").click(
            function () {
                setTimeout(
                    function () {
                        jQuery('select[name="woo_wheel_settings_select_posts[]"]').next(".select2").find("input.select2-search__field").attr("placeholder", "Choose Posts...")
                    }, 10
                )
            }
        );

        jQuery("#wheel_start_date").datepicker(
            {
                dateFormat: "MM d, yy",
                minDate: 0
            }
        );



        jQuery("#wheel_end_date").datepicker(
            {
                dateFormat: "MM d, yy",
                minDate: 0
            }
        );
        jQuery.datepicker.setDefaults(jQuery.datepicker.regional['en']);
        if(!jQuery('#woo_wheel_enable_limited_time').is(':checked') ) {
            jQuery(this).closest('.form-table').find('tr:nth-child(5)').hide();
            jQuery(this).closest('.form-table').find('tr:nth-child(6)').hide();
        }

        jQuery(document).on(
            'click','#woo_wheel_enable_limited_time',function () {        
                update_limited_time_fields();
            }
        );

        update_limited_time_fields();    
    }
);

function update_limited_time_fields()
{
    if (jQuery('#woo_wheel_enable_limited_time').is(':checked')) {
        jQuery('#wheel_start_date').closest('tr').show();
        jQuery('#wheel_end_date').closest('tr').show();
    } else {
        jQuery('#wheel_start_date').closest('tr').hide();
        jQuery('#wheel_end_date').closest('tr').hide();
    }
}

// Make save button clickable while deleting and uploading wheel icon button
jQuery(document).ready(function ($) {

    $('.remove-image').click(function() {
        $('.woocommerce-save-button').prop('disabled', false);
    })
    $('.ww-image-box').click(function() {
        $('.woocommerce-save-button').prop('disabled', false);
    })

    $('.woo_wheel_pages').on('change', function() {
        if ($(this).is(':checked')) {
            // Hide the button when the checkbox is checked
            let radio = $(this).val();

            if (radio == 'all_pages') {
                $('#woo_wheel_settings_select_pages').closest("tr").hide();
            }
            else if(radio == 'specific_pages') {
                $('#woo_wheel_settings_select_pages').closest("tr").show();
            }
            
        } 
    });
    

    $('.woo_wheel_posts').on('change', function() {
        if ($(this).is(':checked')) {
            // Hide the button when the checkbox is checked
            let radio = $(this).val();

            if (radio == 'all_posts') {
                $('#woo_wheel_settings_select_posts').closest("tr").hide();
            }
            else if(radio == 'specific_posts') {
                $('#woo_wheel_settings_select_posts').closest("tr").show();
            }
            
        } 
    });

    if( $('.woo_wheel_pages').prop('checked')) {
        $('#woo_wheel_settings_select_pages').closest("tr").hide()
    }
    
    if( $('.woo_wheel_posts').prop('checked')) {
        $('#woo_wheel_settings_select_posts').closest("tr").hide()
    }
    
})