<?php
/**
 * Class to manage tap button
 */

class Woo_Wheel_Tap {



	public function __construct() {
		add_action('wp_footer', array( $this, 'tap_button' ));
	}

	public function tap_button() {
		
		// Do not show the clickable button If user can't play a wheel
		if (false == is_user_allowed_to_play() || false == is_wheel_allow_on_pages_posts() ) {
			return;
		}
		
		$tap_image            = get_option('woo_wheel_clickable_tab_image', true);
		$enable_clickable_btn = woo_wheel_get_option('woo_wheel_enable_clickable_btn');
		$btn_text             = woo_wheel_get_option('woo_wheel_settings_clickable_button_text');
		
		if (! empty($tap_image) && 'yes' == $enable_clickable_btn ) :?>
		<div id="woo_wheel_icon" class="spin_wheel_icon" style="right: 20px; display:none;">
			<div class="spin_icon_text" style="opacity: 1; visibility: visible;">
				<span class="privy-floating-text"><?php echo esc_html($btn_text); ?></span>
			</div>
			<div class="spin_icon_img">
				<img src="<?php echo esc_attr(wp_get_attachment_url($tap_image)); ?>" style="animation-name: spin; animation-duration: 2000ms; animation-iteration-count: 1; animation-timing-function: linear;">
			</div>
		</div>
			<?php  
		endif;
	}
}

$Woo_Wheel_tap = new Woo_Wheel_Tap();
