<?php
/**
 * Plugin Name: Spin Wheel For Woocommerce
 * Version: 1.8.0
 * Description: Fortune Wheel like conversion tool to boost your sales in WooCommerce
 * Author: wpexpertsio
 * Author URI: https://woocommerce.com/vendor/wpexperts/
 * Plugin URI: https://woocommerce.com/products/woowheel/
 * Developer: wpexpertsio
 * Developer URI: https://woocommerce.com/vendor/wpexperts/
 * Text Domain: woo-wheel
 * Woo: 4623923:137243d3d18d69fea3c59b3b0db269f3
 * WC requires at least: 3.0
 * WC tested up to:  9.3.2
 * License: GNU General Public License v3.0
 * License URI: http://www.gnu.org/licenses/gpl-3.0.html
 */

// If this file is called directly, abort.
if (! defined('ABSPATH') ) {
	exit;
}

define('WOO_WHEEL_VERSION', '1.8.0');
define('WOO_WHEEL_SLUG', 'woo_wheel');
define('WOO_WHEEL_TEXTDOMAIN', 'woo-wheel');

define('WOO_WHEEL_THIS', __FILE__);
define('WOO_WHEEL_ROOT_DIR_URL', plugin_dir_url(WOO_WHEEL_THIS));
define('WOO_WHEEL_ROOT_DIR_PATH', plugin_dir_path(WOO_WHEEL_THIS));
define('WOO_WHEEL_DIR', WOO_WHEEL_ROOT_DIR_URL . 'assets/');
define('WOO_WHEEL_INCLUDES_DIR', WOO_WHEEL_ROOT_DIR_PATH . 'includes/');

function woo_wheel_load() {

	include_once WOO_WHEEL_INCLUDES_DIR . 'functions.php' ;
	include_once WOO_WHEEL_INCLUDES_DIR . 'classes/class-woo-wheel-settings.php' ;
	include_once WOO_WHEEL_INCLUDES_DIR . 'classes/class-woo-wheel-view.php' ;
	include_once WOO_WHEEL_INCLUDES_DIR . 'classes/class-woo-wheel-events.php' ;
	include_once WOO_WHEEL_INCLUDES_DIR . 'classes/class-woo-wheel-stats.php' ;
	include_once WOO_WHEEL_INCLUDES_DIR . 'classes/class-woo-wheel-tap.php' ;
}
/**
 * Load the Woo Wheel plugin if WooCommerce is active.
 *
 * This function checks if WooCommerce is active by looking for the plugin file in the list of active plugins.
 * If it is active, it calls the woo_wheel_load() function to load the plugin.
 *
 * @since 1.0.0
 */
if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins'))) ) {
	woo_wheel_load();
}

add_action(
	'before_woocommerce_init', function () {
		if (class_exists(\Automattic\WooCommerce\Utilities\FeaturesUtil::class) ) {
			\Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility('custom_order_tables', __FILE__, true);
		}
	} 
);
